ConcurrentModificationException

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class ConcurrentModificationException

    java.lang.Object
      java.lang.Throwable
          java.lang.Exception
              java.lang.RuntimeException
                  java.util.ConcurrentModificationException

All Implemented Interfaces:
  Serializable

    public class ConcurrentModificationException

extends RuntimeException

This exception may be thrown by methods that have detected concurrent modification of an object when such modification is not permissible.

For example, it is not generally permssible for one thread to modify a Collection while another thread is iterating over it. In general, the results of the iteration are undefined under these circumstances. Some Iterator implementations (including those of all the collection implementations provided by the JRE) may choose to throw this exception if this behavior is detected. Iterators that do this are known as fail-fast iterators, as they fail quickly and cleanly, rather that risking arbitrary, non-deterministic behavior at an undetermined time in the future.

Note that this exception does not always indicate that an object has been concurrently modified by a different thread. If a single thread issues a sequence of method invocations that violates the contract of an object, the object may throw this exception. For example, if a thread modifies a collection directly while it is iterating over the collection with a fail-fast iterator, the iterator will thow this exception.

Note that fail-fast behavior cannot be guaranteed as it is, generally speaking, impossible to make any hard guarantees in the presence of unsynchronized concurrent modification. Fail-fast operations throw `ConcurrentModificationException` on a best-effort basis. Therefore, it would be wrong to write a program that depended on this exception for its correctness: `ConcurrentModificationException` should be used only to detect bugs.

Since:
  1.2
Version:
  1.11, 02/02/00
Author:
  Josh Bloch
See Also:
  `Collection`, `Iterator`, `ListIterator`, `Vector`, `LinkedList`, `HashSet`, `Hashtable`, `TreeMap`, `AbstractList`, Serialized Form

Constructor Summary
`ConcurrentModificationException()` Constructs a ConcurrentModificationException with no detail message.
`ConcurrentModificationException(String message)` Constructs a `ConcurrentModificationException` with the specified detail message.

Method Summary

Methods inherited from class java.lang.Throwable
`fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ConcurrentModificationException

    public ConcurrentModificationException()

  Constructs a ConcurrentModificationException with no detail message.

### ConcurrentModificationException

    public ConcurrentModificationException(String message)

  Constructs a `ConcurrentModificationException` with the specified detail message.

  Parameters:
    `message` - the detail message pertaining to this exception.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD